<template>
  <object
      v-if="currentSettings"
      type="application/pdf"
      :data="pdfFileUrl"
      class="pic-container__contain-object"
  ></object>
  <p v-else-if="showErrors">
    {{
      currentSettings.remoteFiles
          ? t("no_urls_message")
          : t("no_uploads_message")
    }}
  </p>
</template>
<script>
module.exports = {
  name: "mirros-widget-embed-pdf",
  props: {
    currentSettings: {
      type: Object,
      required: true
    },
    currentStyles: {
      type: Object,
      required: true
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    sourcesConfigured: {
      type: Boolean,
      required: false
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  data: function () {
    return {
      pdfFileUrl: null,
    };
  },
  watch: {
    currentSettings: function (newVal, oldVal) {
      // TODO: Disable rotation if we have just one picture, but re-enable once it's > 1 again
      if (
          newVal.remoteFiles !== oldVal.remoteFiles ||
          newVal.remotePdfFileUrl !== oldVal.remotePdfFileUrl ||
          newVal.pdfFileId !== oldVal.pdfFileId
      ) {
        this.fetchPdfFileUrl();
      }
    },
  },
  computed: {
    showErrors: function () {
      return this.$store.getters.showErrorNotifications;
    },
  },
  beforeMount: async function () {
    await this.fetchPdfFileUrl();
  },
  methods: {
    fetchPdfFileUrl: async function () {
      if (this.currentSettings.remoteFiles) {
        this.pdfFileUrl = this.currentSettings.remotePdfFileUrl;
      } else {
        const data = await fetch(`${this.backendUrl}embed_pdf/pdf_uploads/${this.currentSettings.pdfFileId}`)
            .then((res) => res.json())
            .catch(err => console.log(err));
        this.pdfFileUrl = data.file_url;
      }
    },
  },
  locales: {
    enGb: {
      no_uploads_message: "Please upload a PDF from your device first",
      no_urls_message: "Please add a link to a PDF file first",
      invalid_url_label: "Invalid URL. Please check in settings",
    },
    deDe: {
      no_uploads_message: "Bitte wähle zuerst ein PDF von deinem Gerät",
      no_urls_message: "Bitte füge zuerst einen Link zu einer PDF-Datei ein",
      invalid_url_label: "Ungültige URL. Bitte in den Einstellungen überprüfen",
    },
    frFr: {
      no_uploads_message:
          "Veuillez d'abord choisir des images de votre appareil",
      no_urls_message: "Veuillez d'abord ajouter des liens d'image",
      invalid_url_label: "URL invalide. Veuillez vérifier les paramètres",
    },
    esEs: {
      no_uploads_message: "Elija primero algunas imágenes de su dispositivo",
      no_urls_message: "Primero agregue algunos enlaces de imágenes",
      invalid_url_label: "URL invalida. Por favor revise la configuración",
    },
    plPl: {
      no_uploads_message:
          "Najpierw wybierz kilka obrazów ze swojego urządzenia",
      no_urls_message: "Najpierw dodaj linki do obrazów",
      invalid_url_label: "Nieprawidłowy URL. Proszę sprawdzić ustawienia",
    },
    koKr: {
      no_uploads_message: "먼저 장치에서 일부 이미지를 선택하십시오",
      no_urls_message: "먼저 이미지 링크를 추가하세요.",
      invalid_url_label: "잘못된 URL. 설정에서 확인하십시오",
    },
  },
};
</script>
<style>
.pic-container {
  position: relative;
  height: 100%;
  width: 100%;
  display: flex;
  align-items: inherit;
  justify-content: inherit;
  list-style-type: none;
}

.pic-container__item {
  width: inherit;
  height: inherit;
}

.pic-container__contain {
  object-fit: contain;
  max-width: 100%;
  max-height: 100%;
  position: absolute;
}

.pic-container__contain-object {
  object-fit: contain;
  width: 100%;
  height: 100%;
}

.pic-fade-enter-active,
.pic-fade-leave-active {
  transition: all 2s ease-in-out 1s;
}

.pic-fade-enter,
.pic-fade-leave-to {
  opacity: 0;
}
</style>

